# Multi VPN Auto Rotate

## Visão Geral
Este software tem como objetivo **automatizar a rotação de conexões entre múltiplas VPNs** (Virtual Private Networks). Ele garante uma navegação segura e privada, alternando automaticamente entre diferentes servidores VPN disponíveis com o intuito de melhorar a estabilidade e segurança da conexão do usuário.

### Principais Características
- **Troca Automática de VPNs**: O sistema faz a mudança automática de servidores, proporcionando uma conexão sempre estável e segura.
- **Interface Amigável**: O usuário possui uma interface intuitiva para configurar suas preferências de VPN.
- **Compatibilidade Ampla**: Suporta uma variedade de provedores de VPN, permitindo flexibilidade na escolha.
- **Monitoramento de Conexão**: O software monitora a conexão ativa e troca o servidor quando necessário, assegurando que o usuário mantenha uma boa experiência online.

## Funcionalidades
- **Configuração de Servidores VPN**: O usuário pode adicionar, remover ou ajustar as configurações de VPN existentes conforme sua necessidade.
- **Conexão e Desconexão**: Com fácil acesso, o usuário pode se conectar ou desconectar das VPNs desejadas rapidamente.
- **Registro de Atividades**: Mantém um histórico das atividades de troca de VPN e estado de conexão, podendo ser útil para auditoria e análise.
- **Notificações de Status**: O sistema notifica o usuário sobre o estado da conexão, seja sucesso ou falha, oferecendo maior controle e transparência.

## Instalação
Para instalar o **Multi VPN Auto Rotate**, siga os passos abaixo:
1. **Verifique os Requisitos**: Assegure-se de que possui o Python instalado (recomendado a versão 3.6 ou superior).
2. **Clone o Repositório**: Execute o comando `git clone <URL do repositório>` para baixar o código-fonte.
3. **Instale Dependências**: Abra o terminal na pasta do projeto e rode `pip install -r requirements.txt` para instalar as bibliotecas necessárias.
4. **Configuração Inicial**: Edite o arquivo `config.json` para inserir suas informações de configuração específica das VPNs.
5. **Inicie o Aplicativo**: Finalmente, execute o aplicativo usando `python main.py` no terminal.

## Navegação no Sistema
- **Menu Principal**: A partir do menu principal, você pode acessar as opções para conectar, desconectar e visualizar logs das atividades.
- **Configuração**: A tela de configuração permite que o usuário adicione ou remova servidores VPN conforme o desejado.
- **Status de Conexão**: Mostra se o usuário está conectado a uma VPN e qual servidor está sendo utilizado no momento.

## Solução de Problemas
- **Problemas de Conexão**: Se a VPN não conectar, verifique as credenciais fornecidas.
- **Alta Latência na Troca**: Certifique-se que sua conexão à internet está estável; um sinal fraco pode causar lentidão.
- **Erro de Registro**: Comprove que o aplicativo tem permissão para criar e editar logs na pasta designada.

## Contato para Suporte
Para qualquer dúvida ou necessidade de suporte técnico, entre em contato através dos seguintes canais:
- **Email**: suporte@vpnautoreplace.com
- **Horário de Atendimento**: Segunda a Sexta-feira, das 9h às 17h.

## Atualizações e Manutenção
- **Versão Atual**: 1.0
- **Futuras Atualizações**: Novidades e melhorias são planejadas a cada trimestre.
- **Backup de Configurações**: Recomenda-se que os usuários realizem backup de suas configurações de VPN a cada atualização para evitar perdas de dados.