# Multi VPN Auto Rotate

## Visão Geral
Este software foi desenvolvido com o objetivo de automatizar o processo de troca entre múltiplas VPNs (Virtual Private Networks). Ele permite que os usuários mantenham sua conexão segura e privada ao navegar na internet, alternando automaticamente entre diferentes servidores VPN disponíveis.

### Principais Características
- **Troca Automática de VPNs**: Permite a mudança automática de servidores para garantir uma conexão estável.
- **Interface Amigável**: O usuário pode facilmente configurar suas preferências de VPN.
- **Compatibilidade**: Funciona com diversos provedores de VPN.
- **Monitoramento de Conexão**: Acompanha a estabilidade da conexão e troca o servidor se necessário.

## Funcionalidades
- **Configuração de VPNs**: O usuário pode adicionar, remover ou modificar as configurações das VPNs disponíveis.
- **Conexão e Desconexão**: Estabelece ou finaliza conexões com as VPNs selecionadas.
- **Log de Atividades**: Registra as atividades de troca de VPN e status de conexão.
- **Notificações de Estado**: Informa o usuário sobre mudanças de estado e conexões bem-sucedidas.

## Instalação
Para instalar o Multi VPN Auto Rotate, siga os passos abaixo:
1. **Requisitos**: Certifique-se de que você possui Python instalado (versão 3.6 ou superior).
2. **Clone o Repositório**: Utilize o comando `git clone <URL do repositório>`.
3. **Instale Dependências**: Navegue até a pasta do projeto e execute `pip install -r requirements.txt` para instalar as dependências necessárias.
4. **Configuração Inicial**: Edite o arquivo `config.json` para adicionar suas informações de VPN.
5. **Iniciar Aplicativo**: Execute o aplicativo com o comando `python main.py`.

## Navegação no Sistema
- **Menu Principal**: Apresenta as opções de conectar, desconectar e visualizar logs.
- **Tela de Configuração**: Permite ao usuário adicionar ou remover configurações de VPN.
- **Status de Conexão**: Exibe se o usuário está atualmente conectado a uma VPN e que servidor está sendo utilizado.

## Solução de Problemas
- **VPN Não Conecta**: Verifique se as credenciais da VPN estão corretas.
- **Alternância de VPN Lenta**: Certifique-se de que a velocidade da sua conexão com a internet está estável.
- **Erros de Registro**: Confira se o aplicativo tem permissão para gravar logs na pasta designada.

## Contato para Suporte
Para questões ou suporte técnico, entre em contato com a equipe:
- **Email de Suporte**: suporte@vpnautoreplace.com
- **Horário de Funcionamento**: Segunda a Sexta, das 9h às 17h.

## Atualizações e Manutenção
- **Versão Atual**: 1.0
- **Próximas Atualizações**: Novas funcionalidades serão lançadas a cada três meses.
- **Backup**: Recomenda-se realizar backup das configurações de VPN a cada atualização para evitar perda de dados.